﻿#!/usr/bin/python
# -*- encoding: utf-8 -*-
VERSION = '2.00'

import os
import sys
PATH = '\\'.join((sys.argv[0].split('\\')[0:-1]))+'\\'
sys.path.append(PATH)


import cPickle
import PageWidget
import TreeWiget
import HtmlBBcodeParser
import ttk

from Tkinter import *
import webbrowser
import datetime
import tkMessageBox
import urllib
import urllib2
import json
import ConfigParser
import HTMLParser

import time

def clearText(text):
        edited = 0
        out = ''
        #if not text.islower():
        #    text = text.lower()
        #    edited = 1
            
        for s in text:  
            if s in  '\'\\",./<>?{}[]*+-|!@#$%^&*():; ':
                edited = 1    
            else:
                out += s
        return out,edited 
        
def clearTextPoint(text):
        edited = 0
        out = ''
        #if not text.islower():
        #    text = text.lower()
        #    edited = 1
        for s in text:
            if s in  '\'"<>?{}[]*+-|!@#$%^&():; ':
                edited = 1
            elif s in   '\\,/*':   
                edited = 1
                out += '.'
            else:
                out += s
        return out ,  edited     
                
 
        
 

class Esphlp5(Tk):
    def __init__(self,path = None,autoBackup = 1):
        Tk.__init__(self)
        self.autoBackup = autoBackup
        self.curentPage = None
        leftFrame = Frame(self)
        leftFrame.pack(side= 'left',fill = "both",expand  = 1)
        rightFrame = Frame(self)
        rightFrame.pack(side= 'right',fill = "both",expand  = 1)
        self.tree = TreeWiget.TreeWiget(leftFrame)
        def enterCalbak(name):
            self.label['text']=name.replace('go://','--> ') 
        def link(url):
            z = url.split('://',1)
            if z[0] == 'go':
                self.pageSelect(z[1].replace('/','.').replace('\\','.').replace(',','.').split('.'))
            
            else:
               webbrowser.open(url)
        
        self.text = PageWidget.PageWidget(rightFrame, 
                    font = 12,
                    selectbackground ='#C8C8C8',
                    borderwidth  = 3,
                    #height  = 3,
                    cursor = 'arrow',
                    #wrap = "none",
                    wrap = "word",
                    enterCalbak = enterCalbak,
                    linkcommand = link
                    )
        self.path = path            
        self.text.path = path
        self.text.popupCreate(BackCommand = self.backPage,
                              NextCommand=self.nextPage,
                              TranslCommand=self.transl,
                              EditCommand = self.EditCommand)
        self.tree.pageSelect = self.pageSelect 
        
        #self.text.linkcommand = link
        self.pageHistory = []
        self.pageHistoryNext = []
        self.tree.popupCreate(rename = self.renamePage,
                            addchildpage=self.addchildpage,
                            deletepage = self.deletePage)
                            
        self.label = Label(rightFrame,text = '___________')     
        self.label.pack()
        def Motion(e):
            self.x = e.x
            self.y = e.y
        self.bind('<Motion>',Motion)
        def kepressall(e):
            #print e.keycode
            if e.keycode == 36:
                self.backPage(e)    
            if e.keycode == 35:
                self.nextPage(e)
                
                
        self.bind('<KeyRelease>',kepressall)
        
    def transl(self,*e):
        #  Message(self) ?
        poup = Text(self,font = 'verbana 14',
                                height = 15,
                                width = 50,
                                bg = '#F0F6B5',
                                wrap = "word",
                                )
                                
                
        
        poup.bind("<FocusOut>",lambda *e: poup.destroy())                        
        poup.place(x=5,y=5)

        txt = self.text.selection_get().encode('utf-8')
        api_key =  config.get('translater', 'googleAPI') 
        lang = config.get('translater', 'toLang') 
        params = {'key' : api_key,  
                  'q' :txt,
                  'target': lang}
                  
        url = "https://www.googleapis.com/language/translate/v2?%s"    
       
        try:
            x = url % urllib.urlencode(params)
            request = urllib2.Request(x , 
            headers={ 'User-Agent': 'Mozilla/5.0', 'Accept-Charset': 'utf-8' })
            res = urllib2.urlopen(request).read()
            translated = json.loads(res) 
        
            for translations in translated['data']['translations']:  
                trtext = translations['translatedText'] 
                poup.insert(END,parsHTML.unescape(trtext)+'\n')   
        except urllib2.HTTPError, rr:
            poup.insert(END,'I could not connect :( \n congig.cfg  is not corrupt?\n API  for real?\nlanguage is correct and supported by the Google translator?  ')
        except urllib2.URLError, rr:
            poup.insert(END,'I could not connect :(\n network cable is connected?')
            
        poup.focus_force()
      
        
    def backPage(self,*e):
        try:
            pagepath = self.pageHistory[-1]
            if self.curentPage == pagepath:
                del self.pageHistory[-1]
                self.pageHistoryNext.append(pagepath)
                pagepath = self.pageHistory[-1]
            self.pageSelect(pagepath)
            del self.pageHistory[-1]
            self.pageHistoryNext.append(pagepath)
        except IndexError:
            pass
        
    def nextPage(self,*e):
        try:
            pagepath = self.pageHistoryNext[-1]
            self.pageSelect(pagepath)
            del self.pageHistoryNext[-1]
        except IndexError:
            pass
        
                            
    def deletePage(self,path): 
        #print 'delete',path
        if tkMessageBox.askquestion(title='you sure you want to delete this?',
                    message='you sure you want to delete the \n"%s"\n and its descendants?'%path)=='yes':
            pagepath =  path.split('.')
            xdata = self.data 
            for key in pagepath[:-1]:
                xdata = xdata[key.lower()]['child']
                
            self.saveData(forceBakup = 1)    
            del xdata[pagepath[-1]]
            self.saveData()
            self.tree.updateTree()

            
            
        
    def renamePage(self,path):
        #print 'renamePage',path 
        
        entr = ttk.Entry(self)
        entr.place(x=self.x,y=self.y)
        entr.insert(END,path.split('.')[-1])
        entr.focus_force()
        def fout(*e):
            entr.destroy()
            
  
            
        def KeyRelease(e):
            #e.char
            text = entr.get()
            ctext,edited  = clearText(text)
            if edited:
                #print '----'
                entr.delete(0, END)
                entr.insert(END,ctext)   

        def KeyPress(e):
            s = e.char
            if s == '\n' or s == '\r':
                newname = entr.get().strip()
                if newname:
                    xpath = path.split('.')
                    oldname = xpath[-1]
                    
                    self.saveData(forceBakup = 1)
                    data = self.data
                    
                    for key in xpath[:-1]:
                        data = data[key.lower()]['child']
                        
                         
                    if oldname != newname.lower():    
                        data[newname.lower()] = data[oldname]
                        del data[oldname]
                    data[newname.lower()]['caption'] = newname
                    self.saveData()
                    self.tree.updateTree()
                    
                #print 'ok save'
                entr.destroy()
            if s in '\'",./<>?{}*+-|!@#$%^&*() ':
                return 'break'  

            
        entr.bind("<FocusOut>",fout)
        entr.bind("<KeyRelease>", KeyRelease)
        entr.bind("<KeyPress>", KeyPress)
        
        
        
        

        

        
        
    def addchildpage(self,path):
        saveasmain = Toplevel(self)
        saveasmain.title("add page")
        tree = ttk.Treeview( saveasmain,selectmode = 'browse')
        
        def comsaveas(*e):
            text = entr.get()
            path =  text.split('.')
            if '' in path:
                #print 'bad path',path
                tkMessageBox.showwarning( "bad path",
                   "subpages are separated by a dot.\nname can not be empty\n%s"%path )
                saveasmain.focus()
                return
            else:    
                xdata = self.data
                for key in path[:-1]:
                    lkey = key.lower()
                    if lkey not in xdata:
                       
                        xdata[lkey] = {'caption':key,
                                      'bbcode':' no page [b]%s[/b] (automatic create)'%key, 
                                      'lowertext':'', 
                                      'child':{ }
                                      }
                    #lastdata = xdata    
                    xdata = xdata[lkey]['child']        
                
                
                lastdata = xdata
                key = path[-1]
                lkey = key.lower()
                if lkey in lastdata:
                    
                    if not tkMessageBox.askquestion(title='page already exists!',
                                                    message='Page already exists.\n"%s"\nOverwrite the page?'%path)=='yes':
                        return
                
                self.saveData(forceBakup = 1)
                lastdata[lkey] =  { }  
                lastdata[lkey]['child'] =  { }   
                lastdata[lkey]['caption'] =  key   
                lastdata[lkey]['bbcode'] =  'edit this'   
                lastdata[lkey]['lowertext'] = ''
                saveasmain.destroy()
                #main.title("Edit %s"%'.'.join(pagepath))
                self.saveData()
                self.tree.updateTree()
                self.curentPage = path
                self.EditCommand()
                #self.curentPage = '1111'
                id =  self.tree.getID([pp.lower() for pp in path])
                self.tree.focus(id)
                self.tree.see(id)
                self.tree.selection_set(id)
                
        scrY = ttk.Scrollbar(saveasmain)
        scrY.config(command=tree.yview) 
        tree.config(yscrollcommand=scrY.set)
        entr = ttk.Entry(saveasmain)
        but = ttk.Button(saveasmain,text = 'save',command = comsaveas)
        
        
        scrY.grid(row=0 ,column=1 , sticky='ns')
        tree.grid(row=0 ,column=0 , sticky='nsew')
        entr.grid(row= 1,column= 0,sticky='ew')  
        but.grid(row= 2,column=0 ,)    
        saveasmain.rowconfigure(0, weight=1)
        saveasmain.columnconfigure(0, weight=1)
        
        def entr_Entry_KeyRelease(*event):
            text = entr.get()

            ctext, edited = clearTextPoint(text)    
            if edited:
                #print 'edited'
                entr.delete(0, END)
                entr.insert(END,ctext)  
                #entr.insert(END,text.lower().replace(' ','').replace('/','.').replace('\\','.').replace(',','.'))    
            
       

        
        
        entr.bind("<KeyRelease>", entr_Entry_KeyRelease)
        class TreCliker:
            def __init__(self,name):
                self.name = name
            def __call__(self,*e):    
                entr.delete(0, END)
                entr.insert(END, self.name+'.')
                
        def insertR(idParent,data,tagname):
            for key in sorted(data.keys()):
                tag = tagname+'.'+key
                id = tree.insert(idParent, 'end', text=key, tags=(tag))
                tree.tag_bind(tag, '<1>', TreCliker(tag))
                insertR(id,data[key]['child'],tag)
        
        for key in sorted(self.data.keys()):
            id = tree.insert('', 'end', text=key, tags=(key))
            tree.tag_bind(key, '<1>', TreCliker(key))

            insertR(id,self.data[key]['child'],key)
         
        
        
        
        
        
        
        
        
        
        
        
    def EditCommand(self):
        pagepath = self.curentPage
        main = Toplevel(self)
        main.title("Edit %s"%'.'.join(pagepath))
         
        
        xdata = self.data 
        for key in pagepath[:-1]:
            xdata = xdata[key.lower()]['child']
        page = xdata[pagepath[-1].lower()]   
        topframe = Frame(main)  
        topframe.pack(side = 'top')   
        text2 = Text(main,font = 12,wrap = "none")
        def insertag(tag1,tag2):
            def foo():
                #tag1 = '[ttt]'
                #tag2 = '[/ttt]'
                try:
                    text2.insert(SEL_FIRST,tag1)
                    text2.insert(SEL_LAST,tag2)
                except:    
                    text2.insert(INSERT,tag1+tag2)
                text2.focus()    
            return foo        
                
        def save():
            #self.saveData(forceBakup = 1)
            contents = text2.get(1.0, END)
            page['bbcode'] = contents
            page['lowertext'] = contents.lower() 
            self.saveData()
 
            id =  self.tree.getID([pp.lower() for pp in pagepath])
            self.tree.focus(id)
            self.tree.see(id)
            self.tree.selection_set(id)
            self.text.putBBCODE(contents)
            #
            #self.tree.see(id,open = 1)
            
        def saveas():
            saveasmain = Toplevel(main)
            saveasmain.title("Save as...")
            tree = ttk.Treeview( saveasmain,selectmode = 'browse')
            
            def comsaveas(*e):
                text = entr.get()
                path =  text.split('.')
                if '' in path:
                    #print 'bad path',path
                    tkMessageBox.showwarning( "bad path",
                       "subpages are separated by a dot.\nname can not be empty\n%s"%path )
                    saveasmain.focus()
                    return
                else:    
                    xdata = self.data
                    for key in path[:-1]:
                        lkey = key.lower()
                        if lkey not in xdata:
                           
                            xdata[lkey] = {'caption':key,
                                          'bbcode':' no page [b]%s[/b] (automatic create)'%key, 
                                          'lowertext':'', 
                                          'child':{ }
                                          }
                        #lastdata = xdata    
                        xdata = xdata[lkey]['child']        
                    
                    lastdata = xdata
                    key = path[-1]
                    lkey = key.lower()
                    if lkey in lastdata:
                        if not tkMessageBox.askquestion(title='page already exists!',
                                                    message='Page already exists.\n"%s"\nOverwrite the page?'%path)=='yes':
                            return
                    
                    
                    btext = text2.get(1.0, END)   
                    self.saveData(forceBakup = 1)
                    lastdata[lkey] = {}
                    lastdata[lkey]['child'] =  {}   
                    lastdata[lkey]['caption'] =  key   
                    lastdata[lkey]['bbcode'] =  btext   
                    lastdata[lkey]['lowertext'] = btext.lower() 
                    
                    saveasmain.destroy()
                    main.destroy()
                    #main.title("Edit %s"%'.'.join(pagepath))
                    self.saveData()
                    self.tree.updateTree()
                    self.curentPage = path
                    self.EditCommand()
                    #self.curentPage = '1111'
                    id =  self.tree.getID([pp.lower() for pp in pagepath])
                    self.tree.focus(id)
                    self.tree.see(id)
                    self.tree.selection_set(id)
                    
            scrY = ttk.Scrollbar(saveasmain)
            scrY.config(command=tree.yview) 
            tree.config(yscrollcommand=scrY.set)
            entr = ttk.Entry(saveasmain)
            but = ttk.Button(saveasmain,text = 'save',command = comsaveas)
            
            
            scrY.grid(row=0 ,column=1 , sticky='ns')
            tree.grid(row=0 ,column=0 , sticky='nsew')
            entr.grid(row= 1,column= 0,sticky='ew')  
            but.grid(row= 2,column=0 ,)    
            saveasmain.rowconfigure(0, weight=1)
            saveasmain.columnconfigure(0, weight=1)
            
            def entr_Entry_KeyRelease(*event):
                text = entr.get()
                ctext, edited = clearTextPoint(text) 
                
                if edited:
                    #print 'edited'
                    entr.delete(0, END)
                    
                    entr.insert(END,ctext) 
                    #entr.insert(END,text.lower().replace(' ','').replace('/','.').replace('\\','.').replace(',','.'))    
                    
           

            
            
            entr.bind("<KeyRelease>", entr_Entry_KeyRelease)
            class TreCliker:
                def __init__(self,name):
                    self.name = name
                def __call__(self,*e):    
                    entr.delete(0, END)
                    entr.insert(END, self.name+'.')
                    
            def insertR(idParent,data,tagname):
                for key in sorted(data.keys()):
                    tag = tagname+'.'+key
                    id = tree.insert(idParent, 'end', text=key, tags=(tag))
                    tree.tag_bind(tag, '<1>', TreCliker(tag))
                    insertR(id,data[key]['child'],tag)
            
            for key in sorted(self.data.keys()):
                id = tree.insert('', 'end', text=key, tags=(key))
                tree.tag_bind(key, '<1>', TreCliker(key))
  
                insertR(id,self.data[key]['child'],key)
                
                
            
        Button(topframe,text = 'save',command = save).pack(side = 'left')    
        Button(topframe,text = 'save as',command = saveas).pack(side = 'left')      
            
        ttk.Button(topframe,text = 'go',command = insertag('[GO]','[/GO]')).pack(side = 'left')    
        ttk.Button(topframe,text = 'url',command = insertag('[url]','[/url]')).pack(side = 'left')    
        ttk.Button(topframe,text = 'code',command = insertag('[code]','[/code]')).pack(side = 'left')    
        ttk.Button(topframe,text = 'B',command = insertag('[B]','[/B]')).pack(side = 'left')    
        ttk.Button(topframe,text = 'I', command = insertag('[I]','[/I]')).pack(side = 'left')    
        ttk.Button(topframe,text = 'S',command = insertag('[S]','[/S]')).pack(side = 'left')    
        ttk.Button(topframe,text = 'U',command = insertag('[U]','[/U]')).pack(side = 'left')    
        ttk.Button(topframe,text = 'SIZE',command = insertag('[SIZE=20]','[/SIZE]')).pack(side = 'left')    
        ttk.Button(topframe,text = 'COLOR',command = insertag('[COLOR="Red"]','[/COLOR]')).pack(side = 'left')    
        ttk.Button(topframe,text = 'CENTER',command = insertag('[CENTER]','[/CENTER]')).pack(side = 'left')    
        ttk.Button(topframe,text = 'IMG',command = insertag('[IMG]','[/IMG]')).pack(side = 'left')    
        ttk.Button(topframe,text = 'H',command = insertag('[H]','[/H]')).pack(side = 'left')    

            
        
        #text2.pack(fill = "both",expand  = 1)
        scrY = ttk.Scrollbar(main)
        scrY.config(command=text2.yview)  
        scrX = ttk.Scrollbar(main,orient='horizontal')
        scrX.config(command=text2.xview)                   
        text2.config(yscrollcommand=scrY.set)
        text2.config(xscrollcommand=scrX.set)
        scrY.pack(side='right',fill = "both",)
        text2.pack(side='top',fill = "both",expand  = 1)
        scrX.pack(side='bottom',fill = "both",)  
        
        text2.insert(END,page['bbcode'])
        
        
    def pageSelect(self,pagepath):
        pagepath = [x.lower() for x in pagepath]
        if self.curentPage == pagepath:
            #print 'Nooo, self.curentPage == pagepath   return'
            return
        try:
            t = time.time()
            xdata = self.data 
            for key in pagepath[:-1]:
                xdata = xdata[key.lower()]['child']
            page = xdata[pagepath[-1].lower()] 
            
            
            
            myData = page.get('myData',0)
            if myData:
                typ = 'myData'
                self.text.putPage(myData)
            else:    
                self.text.putBBCODE(page['bbcode'])
                typ = 'bbcode'
            self.curentPage = pagepath
            id =  self.tree.getID([pp.lower() for pp in pagepath])
            self.tree.focus(id)
            self.tree.see(id)
            self.tree.selection_set(id)
            if pagepath not in self.pageHistory:
                self.pageHistory.append(pagepath)
                
            print typ,time.time()  -t  
            
        except KeyError:
            link = '.'.join(pagepath)
            bb = '[b][SIZE=15][COLOR="Red"]Error[/COLOR][/SIZE]\n %s[/b] bad link'% link   
            self.text.putBBCODE(bb)
  
        
    def loadData(self,fname):
        self.fname = fname
        pkl_file = open(self.path+fname, 'rb')
        self.data = cPickle.load(pkl_file)
        self.tree.pushData(self.data)
        pkl_file.close()
        
        if self.data.get('_home',0):
            self.pageSelect(('_home',))
            
    def saveData(self,fname = None,forceBakup = 0):
        if not fname:
            fname = self.fname
        if forceBakup and self.autoBackup:    
            d= str(datetime.datetime.now()).replace(':','-')
            bak = self.path+'backup\\%ssave.db'%d  #
            #print [bak]
            f= open(bak,'wb') 
            f.write(open(self.path+fname, 'rb').read())
            f.close()
            return
     

        output = open(PATH+fname, 'wb')
        cPickle.dump( self.data, output)
        output.close()
        
        
parsHTML = HTMLParser.HTMLParser()      

config = ConfigParser.RawConfigParser()
config.read(PATH+'config.cfg')

root =  Esphlp5(path =PATH,autoBackup = 1)    
root.loadData('data.db')   # data.db
root.title('help EventScripts Python     v%s'%VERSION)

root.wm_iconbitmap(PATH+'img/esph1.ico')

#esph1.ico

root.mainloop()

